/*
 *
 *X509 Dump
 *
 *19.11.01 / urut
 *
 */

package ch.easc.tests;

import java.io.*;
import java.lang.*;

import org.bouncycastle.asn1.*;
import org.bouncycastle.asn1.x509.*;
import org.bouncycastle.asn1.util.*;

import org.bouncycastle.util.test.*;
import org.bouncycastle.util.encoders.*;

public class X509Dump
{
    public static void checkCertificate(byte[]  cert)
    {
        ByteArrayInputStream    bIn;
        DERInputStream          dIn;
        String                  dump = "";

        try
        {
            bIn = new ByteArrayInputStream(cert);
            dIn = new DERInputStream(bIn);

            DERConstructedSequence      seq = (DERConstructedSequence)dIn.readObject();
            
            dump = ASN1Dump.dumpAsString(seq);
            
            //dump = DERDump.dumpAsString(seq);
            System.out.println(dump);
            System.out.println("end of dump");
            //X509CertificateStructure    obj = new X509CertificateStructure(seq);
        }
        catch (Exception e)
        {
            System.out.println("problem in checkCertificate: " + e.getMessage() );
            e.printStackTrace();
        }

    }

    public static void main(String[]    args)
    {
        if ( args.length != 2 )
        {
            System.out.println("wrong cmd line args");
            System.out.println("DERMode filename or PEMMode filename");
            return;
        }
            
        System.out.println("reading file: " + args[1] );
        
        try {
            //read file
            String base64Input = new String();
            
            byte[] cert = null;
            
            if ( args[0].equals( "PEMMode" ) ) {
                BufferedReader dStream = new BufferedReader(new InputStreamReader(new FileInputStream(args[1])));

                while ( dStream.ready() )
                {
                    String line = dStream.readLine();
                
                    if ( !line.substring(1,4).equals("---") )
                    {
                        base64Input += line;
                    }
                }
            
            
                System.out.println("base64 input is: " + base64Input);
            
            
                //base64 decode        
                cert = Base64.decode( base64Input ); 
                System.out.println("length " + cert.length);            
            } else {
                //read DER
                FileInputStream f= new FileInputStream(args[1]);
                System.out.println( args[1]);
                System.out.println( f.available() );
                
                cert = new byte [f.available() ];
                System.out.println("reade " + f.read(cert) );
               
                System.out.println( cert.length );
                
            }
            
            //display content
            checkCertificate(cert);
        } catch (Exception e)
        {
            System.out.println("something went wrong : " + e.getMessage() );
        }
        
    }
}
