package ch.othello.openscep;

import Acme.Serve.Serve;
import ch.othello.openscep.servlet.BasicRequestServlet;

/** Scep Client
 *
 * <pre>
 * $Id: HttpClient.java,v 1.3 2002/02/27 04:21:27 urut Exp $
 * $Log: HttpClient.java,v $
 * Revision 1.3  2002/02/27 04:21:27  urut
 * first working spkac version
 *
 * Revision 1.2  2002/02/14 21:43:55  alani
 * added a startup switch for the location of the configfile
 * added redirection with browser detection for unknown urls
 *
 * Revision 1.1  2002/01/24 13:14:54  alani
 * wrote HttpClient
 *
 * </pre>
 *
 * @since $Date: 2002/02/27 04:21:27 $
 * @author  
 * @version $Revision: 1.3 $
 */

public class HttpClient {

	private static String progName = "httpClient";
    private ScepClient lnkScepClient;

	public static void main(String[] args) {

		// Parse args.
		int port = 9090;
		String config;

		int argc = args.length;
		int argn;
		for (argn = 0; argn < argc && args[argn].charAt(0) == '-'; ++argn) {
			if (args[argn].equals("-p") && argn + 1 < argc) {
				++argn;
				port = Integer.parseInt(args[argn]);
			} else if (args[argn].equals("-c") && argn + 1 < argc) {
				++argn;
				BasicRequestServlet.setConfigFile(args[argn]);
			} else
				usage();
		}

		if (argn != argc)
			usage();

		// Create the server.
		Serve serve = new Serve(port);

		// Any custom Servlets should be added here.
		serve.addServlet(
			"/netscape/request",
			"ch.othello.openscep.servlet.NetscapeRequestServlet");
		serve.addServlet(
			"/netscape/poll",
			"ch.othello.openscep.servlet.NetscapePollServlet");
		serve.addServlet(
			"/microsoft/request",
			"ch.othello.openscep.servlet.MicrosoftRequestServlet");
		serve.addServlet(
			"/microsoft/poll",
			"ch.othello.openscep.servlet.MicrosoftPollServlet");
		serve.addServlet("*", "ch.othello.openscep.servlet.BrowserDetectionServlet");

		System.out.println("ScepProxy HttpServer started...");

		// And run.
		serve.serve();

		System.exit(0);
	}

	private static void usage() {
		System.err.println("usage:  " + progName + " [-p port] [-c configFile]");
		System.exit(1);
	}
}