/*
 * Log.java
 *
 * Created on February 12, 2002, 2:39 PM
 */

package ch.othello.openscep.internal;

/** Logging
 *
 * <pre>
 * $Id: Log.java,v 1.4 2002/03/02 01:45:16 alani Exp $
 * $Log: Log.java,v $
 * Revision 1.4  2002/03/02 01:45:16  alani
 * set log level to 2
 *
 * Revision 1.3  2002/02/15 06:11:09  urut
 * merge with alani
 * lots of mods for incorporating full support for HTTP communication with SCEPD; Httpd client is now capable of reading multipart-mime (sort of....??) messages
 *
 * Revision 1.2  2002/02/14 11:58:55  urut
 * bug fixed
 *
 * Revision 1.1  2002/02/12 14:21:03  urut
 * initial
 *
 * </pre>
 *
 * @since $Date: 2002/03/02 01:45:16 $
 * @author  urut
 * @version $Revision: 1.4 $
 */

public class Log {

    private static int logLevel = 2;       //0=nothing, 1..3 (1=lowest, 3=highest)
    
    public static void setLogLevel(int plogLevel) {
        logLevel=plogLevel;
    }
    
    public static void debug(String msg) {
        if ( logLevel == 3)
            System.out.println("DEBUG: " + msg );
    }
    
    public static void info(String msg) {
        if ( logLevel >= 2)
            System.out.println("INFO: " + msg );
    }
    
    public static void error(String msg) {
        if ( logLevel > 0 ) 
            System.out.println("ERROR: " + msg);
    }
}
