package ch.othello.openscep.internal;

import java.io.*;
import java.net.*;


/**
 * <pre>
 * $Id: ScepHTTPGet.java,v 1.1 2002/02/07 12:40:56 urut Exp $
 * $Log: ScepHTTPGet.java,v $
 *
 * </pre>
 *
 * @since $Date: 2002/02/07 12:40:56 $
 * @author  
 * @version $Revision: 1.1 $
 */

public class ScepHTTPGet {
	URL url;
	HttpURLConnection connection;
        
        /**
         *
         *
         * constructor
         * @param message Base64 encoded message
         * @param operation
         * @param path
         */
	public ScepHTTPGet( byte[] message, String operation, String path ) {
		try {
			if ( message == null )
				url = new URL( path + "?operation=" + operation );
			else	
				url = new URL( path +  "?operation=" + operation +
				 		"&message=" + URLEncoder.encode( new String( message ) ) );

                        Log.debug("after encoding " + URLEncoder.encode ( new String(message)  ) );
                        
                        Log.info("opening connection to " + path + "  operation " + operation + " msg " + message);
                        
			connection = (HttpURLConnection) url.openConnection();
 	                connection.setRequestMethod("GET");
                        connection.setDoOutput(false);
                        connection.setDoInput(true);
                        //connection.connect();
	
              
		} catch ( MalformedURLException ex ) {
			//ex.printStackTrace();
		} catch ( IOException ex ) {
			//ex.printStackTrace();		
		}
	}
        
	/**
         * constructor with defaults
         * @param message base64 encoded message
         * @param operation
         */
	public ScepHTTPGet( byte[] message, String operation ) {
		this( message, operation, "openscep/pkiclient.exe" );
	}

	public String getContentType() {
		return connection.getContentType();
	}
	
	public String getContentEncoding() {
		return connection.getContentEncoding();
	}
	
	public int getContentLength() {
		return connection.getContentLength();
	}

        /**
         * read content (if there is any)
         *
         * this one is a bit confusing - it reads till the first occurence of "Content-Length", reads the length, reads the two remaining
         * linefeeds and then reads the number of bytes specified as Content-Length. This is the BER encoded content of the message. Everything else 
         * is thrown away/not required.
         *
         */
	public byte[] getContent() {
		
		byte[] theArray = null;
                try {
            
                Log.debug("getting content handler");
                Log.debug("content type is " + connection.getContentType() );
                Log.debug("content length is " + connection.getContentLength() );

                int lengthInt = 0;
                
                InputStream inStream = connection.getInputStream();
                BufferedReader in = new BufferedReader(new InputStreamReader(inStream));

                if ( connection.getContentType().equals("application/octet-stream") ) {
                    
                    String str ="";
                    
                    
                    String line=null;
                    while (true) {
                         line = in.readLine();
                        
                        if ( line == null) break;
                 
                        if ( line.indexOf("Content-Length: ") > -1 ) break;
                        
                        Log.debug("Line read " + line);
                        
                        str+=line;
                    }
                 
                    Log.debug("skip : " + in.readLine() );
                
                    String length = line.substring( line.indexOf(":")+1 );
                
                    length = length.trim();
                    Log.debug("length is : " + length);
                
                    lengthInt = Integer.parseInt(length);
               
                    Log.debug("lengthint is : " + lengthInt );
                    
                } else if (connection.getContentType().equals("application/x-pki-message") ) {
                    lengthInt = ( connection.getContentLength() );
                } else {
                    Log.error("invalid content type");
                    return null;
                }
                
                char[] content = new char[lengthInt];
                in.read( content, 0, lengthInt);
                String strRead = new String(content);
                byte[] bytesRead = strRead.getBytes();
                

                
                Utils.printOutByteArray(bytesRead);

                Log.debug("still available " + inStream.available() );


                return ( bytesRead); 
                    
                } catch ( Exception ex) {
                    	ex.printStackTrace();
                }
		return theArray;
				
	}
        
        /**
         * HTTP code
         **/
        public int getResponseCode() throws IOException {
            return ( connection.getResponseCode() );
        }
        
        /**
         * disconnect 
         *
         */
        public void disconnect() {
           connection.disconnect(); 
        }

}
