package ch.othello.openscep.servlet;

import java.io.IOException;

import Acme.Serve.servlet.ServletException;
import Acme.Serve.servlet.http.HttpServlet;
import Acme.Serve.servlet.http.HttpServletRequest;
import Acme.Serve.servlet.http.HttpServletResponse;



/** Scep Http Servlet for a Netscape Certification Request 
 *
 * <pre>
 * $Id: BrowserDetectionServlet.java,v 1.1 2002/02/14 21:45:37 alani Exp $
 * $Log: BrowserDetectionServlet.java,v $
 * Revision 1.1  2002/02/14 21:45:37  alani
 * made servlet output internationalized
 * added redirection with browser detection for unknown urls
 *
 * 
 * </pre>
 *
 * @since $Date: 2002/02/14 21:45:37 $
 * @author alani
 * @version $Revision: 1.1 $
 */


public class BrowserDetectionServlet extends HttpServlet {

	public void service( HttpServletRequest req, HttpServletResponse response ) throws ServletException, IOException {
		
		String ua = req.getHeader( "user-agent" );
		
		if ( ua != null && Acme.Utils.match( "*MSIE*", ua ) )
			response.sendRedirect("/microsoft/request");
		else
			response.sendRedirect("/netscape/request");
				
	}


}
