package ch.othello.openscep.servlet;

import java.io.IOException;

import Acme.Serve.servlet.ServletOutputStream;
import Acme.Serve.servlet.http.HttpServletResponse;
import ch.othello.openscep.internal.Log;

/** Scep Http Servlet for a Netscape Certification Request 
 *
 * <pre>
 * $Id: MicrosoftPollServlet.java,v 1.5 2002/03/02 01:41:59 alani Exp $
 * $Log: MicrosoftPollServlet.java,v $
 * Revision 1.5  2002/03/02 01:41:59  alani
 * code cleaning
 *
 * Revision 1.4  2002/02/27 04:14:24  alani
 * fixed installation of pk7 certificate
 *
 * Revision 1.3  2002/02/24 23:57:10  alani
 * added decorator functionality
 *
 * Revision 1.2  2002/02/24 22:24:24  alani
 * implemented install certificate, not tested
 *
 * Revision 1.1  2002/01/24 13:14:54  alani
 * wrote HttpClient
 *
 * </pre>
 *
 * @since $Date: 2002/03/02 01:41:59 $
 * @author  
 * @version $Revision: 1.5 $
 */


public class MicrosoftPollServlet extends BasicPollServlet {
    
    public void browserInstallCertificate( HttpServletResponse response ) throws IOException {
		
		response.setContentType("text/html");

		ServletOutputStream p = response.getOutputStream();

		sendHeader( p, "Installing the Certificate");
		p.println("<OBJECT");
		p.println("    classid=\"clsid:43F8F289-7A20-11D0-8F06-00C04FC295E1\"");
		p.println("    CODEBASE=\"xenroll.dll\"");
		p.println("    id=IControl");
		p.println("    >");
		p.println("</OBJECT>");
		p.println("<FORM NAME=\"result\" ENCTYPE=x-www-form-encoded METHOD=POST>");
		p.println("	   <CENTER>");
		p.println("    <H1>" + res.getString("certEnrollmentSuccess") + "/<H1>" );
		p.println("    <INPUT TYPE=\"HIDDEN\" NAME=\"result\" VALUE=\"" +
					   scep.getBase64SignedEndEntityCertificate() + "\">");
		p.println("    <INPUT TYPE=\"BUTTON\"");
		p.println("        NAME=\"" + res.getString("accept") + "\" value=\"Accept\" onClick=\"AcceptCertSub\" language=\"VBScript\">");
		p.println("    <INPUT TYPE=\"BUTTON\"");
		p.println("        NAME=\"" + res.getString("refuse") + "\" value=\"No\" onClick=\"NoAcceptCertSub\" language=\"VBScript\">");
	
		p.println("<script type=\"text/vbscript\">");
		
		p.println("    Sub AcceptCertSub()");
		p.println("      On Error Resume Next");
		//p.println("    document.result.result.value = \"PKCS7\"");

		p.println("      Call IControl.AcceptPKCS7(document.result.result.value)");

		p.println("      If err.Number = 0 Then");
		p.println("          navigate \"/microsoft/poll?a=done\"");
		p.println("      Else");
		p.println("          Alert \"Error: \" & Hex(err)");
		p.println("      End If");

		p.println("    End sub");
		p.println("    Sub NoAcceptCertSub()");
		p.println("      navigate \"/microsoft/poll?a=refused\"");
		p.println("    End sub");

		p.println("</script>");
	
		p.println("</FORM>");
		sendFooter(p);
	}

	public void browserInstallSuccess(
		HttpServletResponse response,
		ServletOutputStream p, String cert) throws IOException {
		Log.error("Error this should not happen on InternetExplorer");
		Log.error("MicrosoftPollServlet, browserInstallSuccess");
	}
    
}
