package ch.othello.openscep.servlet;

import java.io.IOException;
import java.net.URLDecoder;
import java.net.URLEncoder;

import org.bouncycastle.asn1.util.ASN1Dump;

import Acme.Serve.servlet.ServletOutputStream;
import Acme.Serve.servlet.http.HttpServletResponse;
import ch.othello.openscep.internal.Utils;


/** Scep Http Servlet for a Netscape Certification Request 
 *
 * <pre>
 * $Id: NetscapePollServlet.java,v 1.4 2002/03/02 01:42:40 alani Exp $
 * $Log: NetscapePollServlet.java,v $
 * Revision 1.4  2002/03/02 01:42:40  alani
 * fixed & improved cert installation
 *
 * Revision 1.3  2002/02/23 00:02:47  alani
 * refactoring the servlet classes, fixed some errors in BasicRequest & BasicPoll Servlets
 *
 * Revision 1.2  2002/02/14 17:18:17  alani
 * fixed NetscapeRequest, first try at polling
 *
 * Revision 1.1  2002/01/24 13:14:54  alani
 * wrote HttpClient
 *
 * </pre>
 *
 * @since $Date: 2002/03/02 01:42:40 $
 * @author  
 * @version $Revision: 1.4 $
 */


public class NetscapePollServlet extends BasicPollServlet {

	public void browserInstallCertificate( HttpServletResponse response ) throws IOException {

		byte[] cert = org.bouncycastle.util.encoders.Base64.encode( Utils.convertDERObjectToByteArray( 
								scep.getSignedEndEntityCertificate().getDERObject())  );		
				
		response.setContentType("text/html");
		response.setHeader("Refresh", "5;URL=/netscape/poll?cert=" + URLEncoder.encode( new String(cert) ) );
		sendDonePage( response );
		
	}

	public void browserInstallSuccess( HttpServletResponse response, ServletOutputStream p, String cert ) throws IOException {
		
		response.setContentType("application/x-x509-user-cert");		
			
		String gugus = URLDecoder.decode(cert);
		byte[] bytes = org.bouncycastle.util.encoders.Base64.decode(gugus);
		
		response.setContentLength( bytes.length );
		p.write( bytes );	
		
	}

}